create table users (
    id number generated by default on null as identity
    constraint pk_users primary key,
    name varchar2(255) not null
);

create table categories (
    id number generated by default on null as identity
    constraint pk_categories primary key,
    name varchar2(255) not null,
    prio varchar2(10) default 'low' not null
);

alter table categories add constraint c_priority check (prio in ('low', 'medium', 'high'));

create table todo_list (
    id number generated by default on null as identity
    constraint pk_todo_list primary key,

    u_id number not null,
    c_id number not null,

    name varchar2(255) not null,

    completed boolean default false not null
);

alter table todo_list add constraint fk_todo_list_users foreign key (u_id) references users;
create index i_todo_list_users on todo_list (u_id);

alter table todo_list add constraint fk_todo_list_categories foreign key (c_id) references categories;
create index i_todo_list_categories on todo_list (c_id);

EXIT;